﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
// lisää system.printing ja ReachFramework references-listaan
// lisää seuraavat
using System.Printing;
using System.Windows.Xps.Packaging;
using System.Windows.Xps.Serialization;
using System.IO.Packaging;
using System.Windows.Markup;

namespace print
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void buttonTulosta_Click(object sender, RoutedEventArgs e)
        {
            PrintDialog dialog = new PrintDialog();
            if (dialog.ShowDialog() == true)
            { dialog.PrintVisual(print, "Tulostusalue"); }
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            PrintDialog dialog = new PrintDialog();
            if (dialog.ShowDialog() != true) return; 

            StackPanel myPanel = new StackPanel();
            myPanel.Margin = new Thickness(15);
            Image myImage = new Image();
            myImage.Width = dialog.PrintableAreaWidth;
            myImage.Stretch = Stretch.Uniform;
            myImage.Source = new BitmapImage(new Uri("kuva.jpg", UriKind.Relative));
            myPanel.Children.Add(myImage);
            TextBlock myBlock = new TextBlock();
            myBlock.Text = "Tommi kokkaa";
            myBlock.TextAlignment = TextAlignment.Center;
            myPanel.Children.Add(myBlock);

            myPanel.Measure(new Size(dialog.PrintableAreaWidth, dialog.PrintableAreaHeight));
            myPanel.Arrange(new Rect(new Point(0, 0), myPanel.DesiredSize));

            dialog.PrintVisual(myPanel, "Tommi kokkaa");
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            PrintQueueCollection Printers;
            listBox1.Items.Clear();
            // .local antaa normaalit printterit .Connections antaa myös verkkotulostimet
            Printers = new PrintServer().GetPrintQueues(new[] { EnumeratedPrintQueueTypes.Local, EnumeratedPrintQueueTypes.Connections});

            foreach (var queue in Printers)
            {
                listBox1.Items.Add(queue.Name);

                PrintCapabilities capabilities = queue.GetPrintCapabilities();

                foreach (PageMediaSize size in capabilities.PageMediaSizeCapability)
                {
                    listBox1.Items.Add(size);
                 }
            }
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            PrintDialog dialog = new PrintDialog();
            if (dialog.ShowDialog() != true) return;
            // tulostuu samassa muodossa mitä näytöllä ilman seuraavia:
/*
            docreader.Document.ColumnWidth = dialog.PrintableAreaWidth;
            docreader.Document.ColumnGap = 0;
            docreader.Document.PageWidth = dialog.PrintableAreaWidth;
            docreader.Document.PageHeight = dialog.PrintableAreaHeight;
            docreader.Document.PagePadding = new Thickness(40);

            IDocumentPaginatorSource foo = docreader.Document;
            dialog.PrintDocument(foo.DocumentPaginator, "flow dokkari");
*/
            
            // ylläolevien jälkeen näytön ulkoasu vastaa tulostusta... ei hyvä
            // täytyy siis kloonata flowdocument
            // valitettavasti seuraava ei kloonaa BlockUIContainereita

            System.IO.MemoryStream s = new System.IO.MemoryStream();
            TextRange source = new TextRange(docreader.Document.ContentStart, docreader.Document.ContentEnd);
            source.Save(s, DataFormats.Xaml);
            FlowDocument copy = new FlowDocument();
            TextRange dest = new TextRange(copy.ContentStart, copy.ContentEnd);
            dest.Load(s, DataFormats.Xaml);

            copy.ColumnWidth = dialog.PrintableAreaWidth;
            copy.ColumnGap = 0;
            copy.PageWidth = dialog.PrintableAreaWidth;
            copy.PageHeight = dialog.PrintableAreaHeight;
 //           copy.PagePadding = new Thickness(40);
            
            IDocumentPaginatorSource doc = copy;
            DocumentPaginatorWrapper uusi = new DocumentPaginatorWrapper(doc.DocumentPaginator, new Size(copy.PageWidth, copy.PageHeight), new Size(20,20));

            dialog.PrintDocument(uusi, "flow dokkari");

            //  jos ei haluta kirjoittaa levylle niin luodaan memorystream ja annetaan se tiedostonimen sijaan
            //            System.IO.MemoryStream lMemoryStream = new System.IO.MemoryStream();
            Package package = Package.Open("testi.xps", System.IO.FileMode.Create);
            XpsDocument xpsdoc = new XpsDocument(package);

            XpsSerializationManager rsm = new XpsSerializationManager(new XpsPackagingPolicy(xpsdoc), false);
            DocumentPaginator paginator = ((IDocumentPaginatorSource)docreader.Document).DocumentPaginator;

            paginator = new DocumentPaginatorWrapper(paginator, new Size(copy.PageWidth, copy.PageHeight), new Size(20, 20));
            rsm.SaveAsXaml(paginator);

       
        }

        private void button4_Click(object sender, RoutedEventArgs e)
        {
            PrintDialog dialog = new PrintDialog();
            if (dialog.ShowDialog() != true) return;

            FixedDocument document = new FixedDocument();
            document.DocumentPaginator.PageSize = new Size(dialog.PrintableAreaWidth-40, dialog.PrintableAreaHeight-40);

            for (int i = 1; i < 4; i++)
            {

                FixedPage page1 = new FixedPage();
                page1.RenderTransform = new TranslateTransform(20, 20);
                page1.Width = document.DocumentPaginator.PageSize.Width;
                page1.Height = document.DocumentPaginator.PageSize.Height;

                DockPanel panel = new DockPanel();
                panel.Width = page1.Width;
                panel.Height = page1.Height;
                // testiksi taustaväri
                panel.Background = Brushes.Aqua;
                page1.Children.Add(panel);
                panel.LastChildFill = true;

                TextBlock header = new TextBlock();
                // sivun nro ja sivun koko sivun ylälaitaan
                header.Text = i.ToString() + " " + document.DocumentPaginator.PageSize.Width.ToString() + " " + document.DocumentPaginator.PageSize.Height.ToString();

//                header.Margin = new Thickness(-20, -20, 0, 0);
                panel.Children.Add(header);
                DockPanel.SetDock(header, Dock.Top);

                TextBlock footer = new TextBlock();
                footer.Text = "Alatunniste";
                footer.HorizontalAlignment = HorizontalAlignment.Right;
                //                footer.Margin = new Thickness(-20, -20, 0, 0);
                panel.Children.Add(footer);
                DockPanel.SetDock(footer, Dock.Bottom);


                TextBlock page1Text = new TextBlock();
                page1Text.TextWrapping = TextWrapping.Wrap;
                page1Text.Text = i.ToString() + " Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque et magna lorem, vitae porttitor mauris. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per inceptos himenaeos. Nam vitae orci dui. Vestibulum quis turpis dolor. Morbi scelerisque dui et mauris porta eget condimentum leo vestibulum. Nunc augue risus, egestas non porttitor quis, bibendum sed justo. Pellentesque sed turpis non metus fringilla aliquet. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum vel dictum augue. Mauris tortor ante, volutpat non auctor eu, rhoncus at orci. ";
                page1Text.FontSize = 10;
                //                page1Text.Width = page1.Width;
                //                page1Text.Height = page1.Height-200;
                //                page1Text.Margin = new Thickness(38);
                panel.Children.Add(page1Text);
                DockPanel.SetDock(page1Text, Dock.Top);
                

                PageContent page1Content = new PageContent();
                ((IAddChild)page1Content).AddChild(page1);
                document.Pages.Add(page1Content);

            }

            dialog.PrintDocument(document.DocumentPaginator, "Fixed document");
        }
    }

    public class DocumentPaginatorWrapper : DocumentPaginator
    {

        Size m_PageSize;
        Size m_Margin;
        DocumentPaginator m_Paginator;
        Typeface m_Typeface;

        public DocumentPaginatorWrapper(DocumentPaginator paginator, Size pageSize, Size margin)
        {
            m_PageSize = pageSize;
            m_Margin = margin;
            m_Paginator = paginator;
            m_Paginator.PageSize = new Size(PageSize.Width - margin.Width * 2,
                                            PageSize.Height - margin.Height * 2);
            m_Typeface = new Typeface("Times New Roman");
        }

        Rect Move(Rect rect)
        {
            return rect;
            if (rect.IsEmpty)
            {
                return rect;
            }
            else
            {
                return new Rect(rect.Left + m_Margin.Width, rect.Top + m_Margin.Height,
                                rect.Width, rect.Height);
            }
        }

        public override DocumentPage GetPage(int pageNumber)
        {
            DocumentPage page = m_Paginator.GetPage(pageNumber);

            ContainerVisual newpage = new ContainerVisual(){  
                Transform = new TranslateTransform( m_Margin.Width, m_Margin.Height      )}; 
            
            DrawingVisual title = new DrawingVisual();

            using (DrawingContext ctx = title.RenderOpen())
            {
                FormattedText text = new FormattedText("Sivu " + (pageNumber + 1),
                    System.Globalization.CultureInfo.CurrentCulture, FlowDirection.LeftToRight,
                    m_Typeface, 18, Brushes.Black);
                ctx.DrawText(text, new Point(-m_Margin.Width/2, -m_Margin.Height)); // sisällön yläpuolella
            }

            DrawingVisual background = new DrawingVisual();

            using (DrawingContext ctx = background.RenderOpen())
            {
                ctx.DrawRectangle(Brushes.Silver, null, page.ContentBox);
            }

            newpage.Children.Add(background);

            ContainerVisual smallerPage = new ContainerVisual();

            smallerPage.Children.Add(page.Visual);

            newpage.Children.Add(smallerPage);

            newpage.Children.Add(title);

            return new DocumentPage(newpage);
//            return new DocumentPage(newpage, m_PageSize, Move(page.BleedBox), Move(page.ContentBox));
        }

        public override bool IsPageCountValid
        {
            get
            {
                return m_Paginator.IsPageCountValid;
            }
        }

        public override int PageCount
        {
            get
            {
                return m_Paginator.PageCount;
            }
        }

        public override Size PageSize
        {
            get
            {
                return m_Paginator.PageSize;
            }

            set
            {
                m_Paginator.PageSize = value;
            }

        }
       public override IDocumentPaginatorSource Source
        {
            get
            {
                return m_Paginator.Source;
            }
        }
    }
}
